// JavaScript Document
/* funkcja wywietlajca komunikat o bdzie */
function displayError(err_str){
  // wywietla komunikat bdu - bardziej szczegowy jeli debugMode ma warto true
  alert("Bd podczas dostpu do serwera! " + "\n" + err_str );
}

//tworzy instancj obiektu XMLHttpRequest
function createXmlHttpRequestObject(){
  // przechowa odowanie do obiektu XMLHttpRequest
  var xmlHttp;
  // powinno zadziaa dla wszystkich przegldarem z wyjtkiem IE6 i starszych
  try{
      // prbuje utworzy obiekt XMLHttpRequest
      xmlHttp = new XMLHttpRequest();
  } catch(e) {
    // zakadajc, e IE6 lub starsza
    var XmlHttpVersions = new Array("MSXML2.XMLHTTP.6.0",
      "MSXML2.XMLHTTP.5.0",
      "MSXML2.XMLHTTP.4.0",
      "MSXML2.XMLHTTP.3.0",
      "MSXML2.XMLHTTP",
      "Microsoft.XMLHTTP");
    // prbuje wszystkie wartoci progId, a jedna zadziaa
    for (var i = 0; i < XmlHttpVersions.length && !xmlHttp; i++)
    {
      try
      {
        // prbuje stworzy obiekt XMLHttpRequest
        xmlHttp = new ActiveXObject(XmlHttpVersions[i]);
      }
      catch (e) {}
    }
  }

  // zwraca utworzony obiekt lub wywietla komunikat o bdzie
  if (!xmlHttp){
      alert("Bd podczas tworzenia obiektu XMLHttpRequest.");
  }else{
      return xmlHttp;
  }
}


function server_odp(o_http, handle_response ){
    if ( !o_http  ){
        return ;
    }

    if ( o_http.readyState == 4 ){
        // tylko jeli status dania HTTP jest "OK"
        try{
            if ( o_http.status == 200 ){

                if( o_http.responseXML && o_http.responseXML.documentElement ){
                    var xmlRoot =  o_http.responseXML.documentElement;

                    var o_errors_xml = [];

                    if( typeof(handle_response) != 'object' && !handle_response.pomin_bledy && !handle_response.skip_errors  ){
                        try{
                            o_errors_xml = xmlRoot.getElementsByTagName('error');
                        }catch( e ){
                            displayError("Wystpi bd w funkcji: server_odp(o_http, handle_response). Komunikat bdu: "+ e.toString() +", jest zwizany z brakiem funckji: getElementsByTagName() w objekcie xmlRoot. By moe odpowied zwrcona z serwera nie jest w formacie xml: \n" + typeof(o_http.responseXML) + str );
                            return false;
                        }
                    
                        if( o_errors_xml && o_errors_xml.length > 0 ){

                            var errors = [];

                            var err_str = 'Wystpiy nastpujce bdy: '+ "\n";

                            // przeszukuje w ptli wszystkie wzy XML, pobierajc ich zawarto
                            for(var i = 0; i < o_errors_xml.length; i++){
                                errors[i] = o_errors_xml.item(i).getAttribute('str');
                                err_str += errors[i] + "\n";
                            }

                            alert( err_str );

                            return false;
                        }
                    }

                    if( typeof(handle_response) == 'object' && typeof(handle_response.funkcja) == 'function' ){
                        handle_response.funkcja( o_http.responseXML.documentElement, o_http.responseText );
                    }else if( typeof(handle_response) == 'function' ){
                        handle_response( o_http.responseXML.documentElement, o_http.responseText );
                    }
                    
                    return null;
                }else{
                    if( typeof(handle_response) != 'function' ){
                        return;
                    }

                    handle_response( o_http.responseText );
                }

                return true;
            }else{
                displayError("Wystpi problem podczas pobierania danych:\n" + o_http.responseText);
            }
        }catch( e ){
            // wywietla komunikat o bdzie
            displayError( 'Funkcja server_odp(o_http, handle_response ) bd: ' +  e.toString() );
        }
    }
}


function server_connect( o_http, url, handle_response ){
    if( !o_http || o_http == null ){
        //tworze nowy obiekt, dzieki temu mozna wywoa t funkc z nullem
        if ( !(o_http = createXmlHttpRequestObject()) ) {
            alert ('Nie udao si utworzy obiektu: XMLHttpRequest. Funcja: server_connect w pliku ajax.js.');
        }
    }

    if( o_http ){
        try{
          /* jeli obiekt XMLHttpRequest nie jest zajty obsug poprzedniego dnia... */
          if ( o_http.readyState == 4 || o_http.readyState == 0){
            //debug.pisz('cze sie z adresem: kontrahenci1.php?id='+ contact_id);
            o_http.open("GET", url, true);

            o_http.onreadystatechange = function(){
                server_odp(o_http, handle_response );
            }

            o_http.send( null );
          }else{
            setTimeout( function(){
                server_connect( o_http, url, handle_response );
            }, 500);
          }
        }catch(e){
            alert("Nie mog poczy si z serwerem:\n" + e.toString());
        }
    }
}




//funkcja wysya formularz za pomoc obiektu xmlHttpRequest i jako funkcj obslugujc
//odpowiedz wzywa funkcj response_function
function send_form( oXmlHttpRequest, formularz, response_function ){
    if( oXmlHttpRequest ){
        try{
        /* jeli obiekt XMLHttpRequest nie jest zajty obsug poprzedniego dnia... */
            if (oXmlHttpRequest.readyState == 4 || oXmlHttpRequest.readyState == 0){
              
              //var uri = new String(formularz.getAttribute('action'));
              var uri = "";
              for( var i = 0; i < formularz.attributes.length; i++ ){
                  var attr = formularz.attributes[i];

                  if( typeof(attr) == 'object' && attr.name == 'action' ){
                      uri = attr.value;
                  }
              }

              if( uri == '' ){
                  uri = new String(window.location);
              }

              var data = '';

              var znak_zapytania_pos = uri.indexOf('?');
              if( znak_zapytania_pos > 0){
                  //uri = uri.substring(0, znak_zapytania_pos );
                  data = uri.substring(znak_zapytania_pos + 1) + '&ajax=1';
                  uri  += '&ajax=1';
              }else{
                  //zeby skrypt wiedzia jak ma zwrci odpowiedzc
                  data = 'ajax=1';
                  uri  += '?ajax=1';
              }
              
              var pole = null;

              for ( pole_nazwa in formularz.elements ){
                  pole = formularz.elements[pole_nazwa];

                  try{
                  if( typeof(pole) == 'object' && pole.type ){
                      if( pole.type.toLowerCase() == 'checkbox' ){
                          if( pole.checked ) data += '&' + pole.name + '=' + pole.value;
                      }else{
                          data += '&' + pole.name + '=' + pole.value;
                      }
                  }
                  }catch(o_err){
                      //nic nie robie z tym bedem, tutaj jest tylko problem pod ie, wystpuj jakies dodatkowe pola ktre powoduja wystapienie bedu, takie jak onmouseover
                  }
              }

              oXmlHttpRequest.onreadystatechange = response_function;

              if( formularz.method.toUpperCase() == 'POST' ){
                oXmlHttpRequest.open('POST', uri, true);

          			try{
                  oXmlHttpRequest.setRequestHeader("Method", "POST " + uri + " HTTP/1.1");
                  oXmlHttpRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
          			}
          			catch(e){
                  displayError("Your browser does not appear to  support asynchronous requests using POST.");
                  return false;
          			}

                oXmlHttpRequest.send( data );
              }else{
                  oXmlHttpRequest.open('GET', uri + '?' + data, true);
                  oXmlHttpRequest.send(null);
              }

              return true;
            }else{
                // jeli jest zajty...
                displayError("Nie mog poczy si z serwerem, poniewa jest serwer zajty...\n" );
                return false;
            }
        }catch(e){
            displayError("Nie mog poczy si z serwerem:\n" + e.toString());
            return false;
        }
    }else{
        displayError("Nieprawidowy obiekt XmlHttpRequest przekazany do funkcji: ajax_send_form\n" );
        return false;
    }
}


function send_post( oXmlHttpRequest, uri, data, response_function ){
    if( oXmlHttpRequest ){
        try{
        /* jeli obiekt XMLHttpRequest nie jest zajty obsug poprzedniego dnia... */
            if (oXmlHttpRequest.readyState == 4 || oXmlHttpRequest.readyState == 0){
                if( data.indexOf('&ajax=1') == -1 ){
                    data += '&ajax=1';
                }

                oXmlHttpRequest.onreadystatechange = function(){
                    server_odp(oXmlHttpRequest, response_function );
                }

                oXmlHttpRequest.open('POST', uri, true);

          			try{
                  oXmlHttpRequest.setRequestHeader("Method", "POST " + uri + " HTTP/1.1");
                  oXmlHttpRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
          			}
          			catch(e){
                  displayError("Your browser does not appear to  support asynchronous requests using POST.");
                  return false;
          			}

                oXmlHttpRequest.send( data );

                return true;
            }else{
                // jeli jest zajty...
                displayError("Nie mog poczy si z serwerem, poniewa jest serwer zajty...\n" );
                return false;
            }
        }catch(e){
            displayError("Nie mog poczy si z serwerem:\n" + e.toString());
            return false;
        }
    }else{
        displayError("Nieprawidowy obiekt XmlHttpRequest przekazany do funkcji: ajax_send_form\n" );
        return false;
    }
}


function ajax_send_form( f ){

  if( adminXmlHttpRequest ){
    try{
      /* jeli obiekt XMLHttpRequest nie jest zajty obsug poprzedniego dnia... */
      if (adminXmlHttpRequest.readyState == 4 || adminXmlHttpRequest.readyState == 0){
        //debug.pisz('cze sie z adresem: kontrahenci1.php?id='+ contact_id);
        var uri  = 'admin.php';

        var data = 'ajax=1';
        for (var i=0; i < f.length; i++){
            current = f.elements[i];
            data += '&' + current.name + '=' + current.value;
        }

        adminXmlHttpRequest.onreadystatechange = function(){ ajax_get_form_response(); }

        if( f.method.toUpperCase() == 'POST' ){
          adminXmlHttpRequest.open('POST', uri, true);

    			try{
      //http_request.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
      //http_request.setRequestHeader("Content-length", parameters.length);
      //http_request.setRequestHeader("Connection", "close");

            adminXmlHttpRequest.setRequestHeader("Method", "POST " + uri + " HTTP/1.1");
            adminXmlHttpRequest.setRequestHeader("Content-Type", "application/x-www-form-urlencoded");
    			}
    			catch(e){
            alert("Your browser does not appear to  support asynchronous requests using POST.");
            return false;
    			}

          adminXmlHttpRequest.send( data );
        }else{
          adminXmlHttpRequest.open('GET', uri + '?' + data, true);
          adminXmlHttpRequest.send(null);
        }
        showTlo();
        showLoading();
      }else{
        // jeli jest zajty...
        alert("Nie mog poczy si z serwerem, poniewa jest serwer zajty...\n" );
      }
    }
    catch(e){
      alert("Nie mog poczy si z serwerem:\n" + e.toString());
      return false;
    }
  }
}


function ajax_get_form_response(){

  //po ukoczeniu procesu, decyduje co zrobi z otrzymanymi danymi
  if (adminXmlHttpRequest.readyState == 4){
    // tylko jeli status dania HTTP jest "OK"
    if (adminXmlHttpRequest.status == 200){
      try{
        hideLoading();

        hideTlo();

        if( adminXmlHttpRequest.responseText == 'OK'){
            alert('Ustawienia zostay zapisane!');
        }else{
            // pobiera element dokumentu
            var err_str = xml_get_errors(adminXmlHttpRequest);
            if( err_str ){
                err_div.innerHTML = err_str;
            }else{
                err_div.innerHTML = adminXmlHttpRequest.responseText;
            }
        }
      }
      catch(e){
        // wywietla komunikat o bdzie
        displayError(e.toString());
      }
    }
    else{
      displayError("Wystpi problem podczas pobierania danych:\n" + this.xmlHttpGetSuggestions.responseText);
    }
  }

}

function  xml_get_errors( xmlHttp ){

    if( xmlHttp.responseXML
          && xmlHttp.responseXML.documentElement
              /* && typeof (xmlHttp.responseXML.documentElement.getElementsByTagName) == 'function' nie dziaa pod ie to sprawdzenie, typeof zwraca unknown */){
        var xmlerr = [];
        try{
            xmlerr = xmlHttp.responseXML.documentElement.getElementsByTagName('error');
        }catch( o_blad ){
            displayError("Wystpi bd w funkcji: xml_get_errors(o_http). Komunikat bdu: " + o_blad.message + ", jest zwizany z brakiem funckji: getElementsByTagName() w objekcie xmlHttp. By moe odpowied zwrcona z serwera nie jest w formacie xml: \n" + xmlHttp.responseText );
            return false;
        }
        

        if( xmlerr.length ){
            var  errors = [];
            // przeszukuje w ptli wszystkie wzy XML, pobierajc ich zawarto
            for(i = 0; i < xmlerr.length; i++){
                errors[i] = xmlerr.item(i).getAttribute('str');
            }

            err_div = document.getElementById('errors');
            err_html = 'Wystpiy nastpujce bdy: ';
            err_html += '<ol>';
            for(i = 0; i < errors.length; i++){
              err_html += '<li class=error>' + errors[i] + '</li>' + "\n";
            }
            err_html += '</ol>';

            return err_html;
        }
    }


    return false;
}



