// JavaScript Document
/**
 *  Klasa do przewijania
 *
 *  @return zwraca obiekt klasy
 *
 *  @param jest to identyfikator obiektu ktry ma byc przewijany
 *  @param jest to identyfikator obiektu szcego do przewijania w poziomie
 *  @param jest to identyfikator obiektu szcego do przewijania w pionie
 *  @param szerokosc w pikselach o jaka ma zostac przewiniety element
 *  @param wysokosc o jaka ma zostac przewiniety element
 *  @param czas po jakim ma zostac przewiniety ponownie element jesli auto jest ustawione na true
 *  @param czy przewijanie ma nastapic automatycznie po najechaniu na strzaki
 *
 */
 
var scroll_obj = [];
var f_mousemove =  null;
var f_mouseup = null;
    
function scroll_class( scroller_id, hslider_id, vslider_id, scroll_width, scroll_height, scroll_time, auto ){

  if( arguments.length < 2){
      alert('Zamaa liczba parametrw przekazana do funkcji!');
      return false;
  }
  
  this.o_scroller = document.getElementById(scroller_id);
  
  if( !this.o_scroller ){
      alert('Obiekt o identyfikatorze: '+scroller_id+' nie istnieje!');
      return false;
  }
  
  this.o_hslider = document.getElementById(hslider_id);
  this.o_vslider = document.getElementById(vslider_id);
  
  if( !this.o_hslider && !this.o_vslider ){
      alert('W dokumencie nie znaleziono adnego suwaka do przewijania zawartosci w pionie ani w poziomie dla obiektu: ' + scroller_id );
      return false;
  }

  this.b_auto = false;
  this.scroll_width = 20;
  this.scroll_height = 20;
  this.scroll_time = 100;
  
  if( arguments.length > 3 ){
      this.scroll_width = scroll_width;

      if( arguments.length > 4 ){
          this.scroll_height = scroll_height;

          if( arguments.length > 5 ){
              this.scroll_time = scroll_time * 1000;
              if( arguments.length > 6 ){
                  this.b_auto = auto;
              }
          }
      }
  }
  

  if( this.o_hslider ){
      this.o_lt = this.o_hslider.getElementsByTagName('img').item(0);
      this.o_rt = this.o_hslider.getElementsByTagName('img').item(1);
      
      this.o_hbar = this.o_scroller.getElementsByTagName('div').item(0);
      this.o_hsuwak = this.o_bar.firstChild;
      //ustalam szerokosci i wysokosci obiektw


      var t = parseInt(this.o_up.offsetTop);
      t = (isNaN(t) )?0:t;
      
      var h = parseInt(this.o_up.clientHeight);
      h = (isNaN(h) )?0:h;
      
      t += h + 2;
      
      this.o_bar.style.top  =  t;
      this.o_bar.style.left = 0;
      
      var t1 = parseInt(this.o_dn.offsetTop);
      t1 = (isNaN(t1) ) ? 0 : t1;
      
      this.o_bar.style.height = ( t1 - t - 2);
      bar_wysokosc = ( t1 - t - 2);
      
      //this.o_bar.style.width  = this.o_scroller.clientWidth;

      this.o_bar.style.left = Math.round((this.o_scroller.clientWidth - this.o_bar.clientWidth) / 2);

      this.o_suwak.style.top = 0;
      this.o_suwak.style.left = 0;
      this.o_suwak.style.width = this.o_bar.clientWidth - 2;

      this.proporcja =  parseFloat(bar_wysokosc) / parseFloat(this.o_slider.scrollHeight);
      this.o_suwak.style.height = Math.floor( this.proporcja * parseFloat(this.o_slider.clientHeight)  ) - 2;

      this.suwak_max_top = Math.round( this.proporcja * parseFloat(this.o_slider.scrollHeight - this.o_slider.clientHeight)  );
      
      this.o_suwak.style.top = Math.round(this.proporcja * parseFloat(this.o_slider.scrollTop));
/*
alert('this.o_slider.clientHeight = ' + this.o_slider.clientHeight + '\n' +
      'this.o_slider.scrollHeight = ' + this.o_slider.scrollHeight + '\n' +
      'proporcja = ' + this.proporcja + '\n' +
      'bar_wysokosc = ' + bar_wysokosc + '\n' +
      'this.o_suwak.style.height = ' + this.o_suwak.style.height);
*/
  }


  if( this.o_vslider ){
      this.o_up = this.o_hslider.getElementsByTagName('img').item(0);
      this.o_dn = this.o_hslider.getElementsByTagName('img').item(1);
      
      this.o_vbar = this.o_scroller.getElementsByTagName('div').item(0);
      this.o_vsuwak = this.o_bar.firstChild;
      //ustalam szerokosci i wysokosci obiektw


      var t = parseInt(this.o_up.offsetTop);
      t = (isNaN(t) )?0:t;

      var h = parseInt(this.o_up.clientHeight);
      h = (isNaN(h) )?0:h;

      t += h + 2;

      this.o_bar.style.top  =  t;
      this.o_bar.style.left = 0;

      var t1 = parseInt(this.o_dn.offsetTop);
      t1 = (isNaN(t1) ) ? 0 : t1;

      this.o_bar.style.height = ( t1 - t - 2);
      bar_wysokosc = ( t1 - t - 2);

      //this.o_bar.style.width  = this.o_scroller.clientWidth;

      this.o_bar.style.left = Math.round((this.o_scroller.clientWidth - this.o_bar.clientWidth) / 2);

      this.o_suwak.style.top = 0;
      this.o_suwak.style.left = 0;
      this.o_suwak.style.width = this.o_bar.clientWidth - 2;

      this.proporcja =  parseFloat(bar_wysokosc) / parseFloat(this.o_slider.scrollHeight);
      this.o_suwak.style.height = Math.floor( this.proporcja * parseFloat(this.o_slider.clientHeight)  ) - 2;

      this.suwak_max_top = Math.round( this.proporcja * parseFloat(this.o_slider.scrollHeight - this.o_slider.clientHeight)  );

      this.o_suwak.style.top = Math.round(this.proporcja * parseFloat(this.o_slider.scrollTop));
/*
alert('this.o_slider.clientHeight = ' + this.o_slider.clientHeight + '\n' +
      'this.o_slider.scrollHeight = ' + this.o_slider.scrollHeight + '\n' +
      'proporcja = ' + this.proporcja + '\n' +
      'bar_wysokosc = ' + bar_wysokosc + '\n' +
      'this.o_suwak.style.height = ' + this.o_suwak.style.height);
*/
  }
  
  this.lp = scroll_obj.length;
  
  this.timeout_id = -1;
  
  var o_self = this;

  scroll_obj[this.lp ] = o_self;
  
/******************************************************************************/
/*      rejestrowanie funkcji rejestrujacej zwolnienie klawisza
/******************************************************************************/
    if (document.addEventListener) {  // DOM Level 2 Event Model
        // Register capturing event handlers
        //debug.pisz('rejestruje przez addEventListener');

        if( auto ){
            this.o_lt.addEventListener("mouseover", function(e){ o_self.scrolling_up(e) }, true);
            this.o_lt.addEventListener("mouseout", function(e){ o_self.scrolling_stop(e) }, true);

            this.o_rt.addEventListener("mouseover", function(e){ o_self.scrolling_dn(e) }, true);
            this.o_rt.addEventListener("mouseout", function(e){ o_self.scrolling_stop(e) }, true);

        }else{
            this.o_lt.addEventListener("mousedown", function(e){ o_self.scrolling_up(e) }, true);
            this.o_lt.addEventListener("mouseup", function(e){ o_self.scrolling_stop(e) }, true);

            this.o_rt.addEventListener("mousedown", function(e){ o_self.scrolling_dn(e) }, true);
            this.o_rt.addEventListener("mouseup", function(e){ o_self.scrolling_stop(e) }, true);
        }
        this.o_hsuwak.addEventListener("mousedown", function(e){ o_self.suwak_mousedown(e) }, true);
        
        //debug.pisz('zarejestrowaem');
    }else if (document.attachEvent) {  // IE 5+ Event Model
        // In the IE Event model, we can't capture events, so these handlers
        // are triggered when only if the event bubbles up to them.
        // This assumes that there aren't any intervening elements that
        // handle the events and stop them from bubbling.
        //debug.pisz('rejestruje przez attachEvent');
        if( auto ){
            this.o_lt.attachEvent("onmouseover", function(e){ o_self.scrolling_up(e) } );
            this.o_lt.attachEvent("onmouseout", function(e){ o_self.scrolling_stop(e) } );

            this.o_rt.attachEvent("onmouseover", function(e){ o_self.scrolling_dn(e) } );
            this.o_rt.attachEvent("onmouseout", function(e){ o_self.scrolling_stop(e) } );
        }else{
            this.o_lt.attachEvent("onmousedown", function(e){ o_self.scrolling_up(e) } );
            this.o_lt.attachEvent("onmouseup", function(e){ o_self.scrolling_stop(e) } );

            this.o_rt.attachEvent("onmousedown", function(e){ o_self.scrolling_dn(e) } );
            this.o_rt.attachEvent("onmouseup", function(e){ o_self.scrolling_stop(e) } );
        }
        this.o_hsuwak.attachEvent("onmousedown", function(e){ o_self.suwak_mousedown(e) } );

        
        //debug.pisz('zarejestrowaem');
    }else {                            // IE 4 Event Model
        // In IE 4 we can't use attachEvent(), so assign the event handlers
        // directly after storing any previously assigned handlers so they
        // can be restored.  Note that this also relies on event bubbling.
        /*var oldmovehandler = document.onmousemove;
        var olduphandler = document.onmouseup;
        document.onmousemove = moveHandler;
        document.onmouseup = upHandler;*/
        //debug.pisz('w ogle nie rejestruje');
        alert('Nie udalo sie utworzyc obiektu do przewijania zawartosci strony :(');
        return false;
    }
  
}

scroll_class.prototype.scroll_up = function(){

    var top = this.o_slider.scrollTop - this.scroll_height;
    
    if( top < 0 ) top = 0;

    this.o_suwak.style.top = Math.round(parseFloat(top) * this.vproporcja);
    
    this.o_slider.scrollTop = top;

}

scroll_class.prototype.scroll_dn = function(){

    var top = this.o_slider.scrollTop + this.scroll_height;

    if( (top + this.o_slider.clientHeight) > this.o_slider.scrollHeight ) top = this.o_slider.scrollHeight - this.o_slider.clientHeight;

    this.o_suwak.style.top = Math.round(parseFloat(top) * this.vproporcja);
    
    this.o_slider.scrollTop = top;

}


scroll_class.prototype.scrolling_up = function(){

    if( this.timeout_id > 0){
        clearTimeout(this.timeout_id);
    }

    var o_self = this;
    
    o_self.scroll_up();
    
    this.timeout_id = setTimeout( function(){ o_self.scrolling_up(); }, this.scroll_time );
}

scroll_class.prototype.scrolling_dn = function(){

    if( this.timeout_id > 0){
        clearTimeout(this.timeout_id);
    }

    this.scroll_dn();
    
    var o_self = this;
    
    this.timeout_id = setTimeout( function(){ o_self.scrolling_dn(); }, this.scroll_time );
}


scroll_class.prototype.scroll_lt = function(){

    var left = this.o_slider.scrollLeft - this.scroll_width;

    if( left < 0 ) left = 0;

    this.o_suwak.style.left = Math.round(parseFloat(left) * this.hproporcja);

    this.o_slider.scrollLeft = left;

}

scroll_class.prototype.scroll_rt = function(){

    var left = this.o_slider.scrollLeft + this.scroll_width;

    if( (left + this.o_slider.clientWidth) > this.o_slider.scrollWidth) left = this.o_slider.scrollHeight - this.o_slider.clientHeight;

    this.o_suwak.style.left = Math.round(parseFloat(left) * this.hproporcja);

    this.o_slider.scrollLeft = left;

}


scroll_class.prototype.scrolling_lt = function(){

    if( this.timeout_id > 0){
        clearTimeout(this.timeout_id);
    }

    var o_self = this;

    o_self.scroll_lt();

    this.timeout_id = setTimeout( function(){ o_self.scrolling_lt(); }, this.scroll_time );
}

scroll_class.prototype.scrolling_rt = function(){

    if( this.timeout_id > 0){
        clearTimeout(this.timeout_id);
    }

    this.scroll_rt();

    var o_self = this;

    this.timeout_id = setTimeout( function(){ o_self.scrolling_rt(); }, this.scroll_time );
}

scroll_class.prototype.scrolling_stop = function(){
    if( this.timeout_id > 0){
        clearTimeout(this.timeout_id);

        this.timeout_id = -1;
    }
}

/**
 * PortableDrag.js:
 * beginDrag() is designed to be called from an onmousedown event handler.
 * elementResize may be the element that received the mousedown event, or it
 * may be some containing element.  event must be the Event object for the
 * mousedown event.  This implementation works with both the DOM Level 2
 * event model and the IE Event model.
 **/

scroll_class.prototype.vsuwak_mousedown = function( e ){
    e = (!e) ? window.event : e;

    this.start_y   = parseInt( e.clientY );
    this.start_top = parseInt(this.o_suwak.offsetTop);

    var o_self = this;

    f_mousemove =  function(e){ o_self.suwak_mousemove(e) };
    f_mouseup = function(e){ o_self.suwak_mouseup(e) };
    
    //window.status = 'x = ' + e.clientX + ', y = ' + e.clientY + ' L = ' + startWidthL + ' P: ' + startWidthP;
    //var deltaY = e.clientY - parseInt(resizeElement.style.top);

    // Register the e handlers that will respond to the mousemove events
    // and the mouseup event that follow this mousedown event.
    if (document.addEventListener) {  // DOM Level 2 Event Model
        // Register capturing event handlers
        document.addEventListener("mousemove", f_mousemove, true);
        document.addEventListener("mouseup", f_mouseup, true);
    }else if (document.attachEvent) {  // IE 5+ Event Model
        // In the IE Event model, we can't capture events, so these handlers
        // are triggered when only if the event bubbles up to them.
        // This assumes that there aren't any intervening elements that
        // handle the events and stop them from bubbling.
        document.attachEvent("onmousemove", f_mousemove );
        document.attachEvent("onmouseup", f_mouseup );
    } else {                            // IE 4 Event Model
        // In IE 4 we can't use attachEvent(), so assign the event handlers
        // directly after storing any previously assigned handlers so they
        // can be restored.  Note that this also relies on event bubbling.
        this.oldmovehandler = document.onmousemove;
        this.olduphandler = document.onmouseup;
        
        document.onmousemove = function(e){ o_self.suwak_mousemove(e) };
        document.onmouseup = function(e){ o_self.suwak_mouseup(e) };
    }

    // We've handled this event.  Don't let anybody else see it.
    if (e.stopPropagation) e.stopPropagation();   // DOM Level 2
    else e.cancelBubble = true;                       // IE

    // Now prevent any default action.
    if (e.preventDefault) e.preventDefault();     // DOM Level 2
    else e.returnValue = false;                       // IE
  
}


/**
  * This is the handler that captures mousemove events when an element
  * is being dragged.  It is responsible for moving the element.
  **/
scroll_class.prototype.vsuwak_mousemove = function (e) {
  	e = (!e) ? window.event : e;  // IE event model

    // Move the element to the current mouse position, adjusted as
  	// necessary by the offset of the initial mouse click.
  	var delta   = (e.clientY - this.start_y );
  	var newTop  = this.start_top  + delta;

    //window.status =  "clientX = " + e.clientX + "startX  = " + startX + 'newWidth = ' + newWidth;

  	if( newTop > this.suwak_max_top ){
      this.o_suwak.style.top = this.suwak_max_top;
      this.o_slider.scrollTop = this.o_slider.scrollHeight - this.o_slider.clientHeight;
      
      //resizeElement.style.visibility = 'visible';
    }else if( newTop < 0 ){
      this.o_suwak.style.top  = 0;
      this.o_slider.scrollTop = 0;
      //resizeElement.style.visibility = 'hidden';
    }else{
      this.o_suwak.style.top = newTop;
      this.o_slider.scrollTop = Math.round(newTop / this.proporcja);
      
      //resizeElement.style.visibility = 'visible';
    }

  	//resizeElement.style.left = (e.clientX - deltaX) + "px";
  	//resizeElement.style.top = (e.clientY - deltaY) + "px";

  	// And don't let anyone else see this event.
  	if (e.stopPropagation)
        e.stopPropagation();       // DOM Level 2
  	else
        e.cancelBubble = true;                       // IE
}

/**
   * This is the handler that captures the final mouseup event that
   * occurs at the end of a drag.
**/
scroll_class.prototype.vsuwak_mouseup = function (e) {
  	if (!e) e = window.event;  // IE event model

  	var delta   = (e.clientY - this.start_y );
  	var newTop  = this.start_top  + delta;
  	
  	//window.status =  "clientX = " + e.clientX + "startX  = " + startX + 'newWidth = ' + newWidth;

  	if( newTop > this.suwak_max_top ){
      this.o_suwak.style.top = this.suwak_max_top;
      this.o_slider.scrollTop = this.o_slider.scrollHeight - this.o_slider.clientHeight;

      //resizeElement.style.visibility = 'visible';
    }else if( newTop < 0 ){
      this.o_suwak.style.top  = 0;
      this.o_slider.scrollTop = 0;
      //resizeElement.style.visibility = 'hidden';
    }else{
      this.o_suwak.style.top = newTop;
      this.o_slider.scrollTop = Math.round(newTop / this.proporcja);

      //resizeElement.style.visibility = 'visible';
    }


  	// Unregister the capturing event handlers.
  	if (document.removeEventListener) {    // DOM Event Model
  	    document.removeEventListener("mouseup", f_mouseup, true);
  	    document.removeEventListener("mousemove", f_mousemove, true);
  	}else if (document.detachEvent) {       // IE 5+ Event Model
  	    document.detachEvent("onmouseup", f_mouseup);
  	    document.detachEvent("onmousemove", f_mousemove);
  	}	else {                                 // IE 4 Event Model
  	    document.onmouseup = this.olduphandler;
  	    document.onmousemove = this.oldmovehandler;
  	}

  	// And don't let the event propagate any further.
  	if (e.stopPropagation)
        e.stopPropagation();       // DOM Level 2
  	else
        e.cancelBubble = true;                       // IE
}


/******************************************************************************/

scroll_class.prototype.hsuwak_mousedown = function( e ){
    e = (!e) ? window.event : e;

    this.start_y   = parseInt( e.clientY );
    this.start_top = parseInt(this.o_suwak.offsetTop);

    var o_self = this;

    f_mousemove =  function(e){ o_self.suwak_mousemove(e) };
    f_mouseup = function(e){ o_self.suwak_mouseup(e) };

    //window.status = 'x = ' + e.clientX + ', y = ' + e.clientY + ' L = ' + startWidthL + ' P: ' + startWidthP;
    //var deltaY = e.clientY - parseInt(resizeElement.style.top);

    // Register the e handlers that will respond to the mousemove events
    // and the mouseup event that follow this mousedown event.
    if (document.addEventListener) {  // DOM Level 2 Event Model
        // Register capturing event handlers
        document.addEventListener("mousemove", f_mousemove, true);
        document.addEventListener("mouseup", f_mouseup, true);
    }else if (document.attachEvent) {  // IE 5+ Event Model
        // In the IE Event model, we can't capture events, so these handlers
        // are triggered when only if the event bubbles up to them.
        // This assumes that there aren't any intervening elements that
        // handle the events and stop them from bubbling.
        document.attachEvent("onmousemove", f_mousemove );
        document.attachEvent("onmouseup", f_mouseup );
    } else {                            // IE 4 Event Model
        // In IE 4 we can't use attachEvent(), so assign the event handlers
        // directly after storing any previously assigned handlers so they
        // can be restored.  Note that this also relies on event bubbling.
        this.oldmovehandler = document.onmousemove;
        this.olduphandler = document.onmouseup;

        document.onmousemove = function(e){ o_self.suwak_mousemove(e) };
        document.onmouseup = function(e){ o_self.suwak_mouseup(e) };
    }

    // We've handled this event.  Don't let anybody else see it.
    if (e.stopPropagation) e.stopPropagation();   // DOM Level 2
    else e.cancelBubble = true;                       // IE

    // Now prevent any default action.
    if (e.preventDefault) e.preventDefault();     // DOM Level 2
    else e.returnValue = false;                       // IE

}


/**
  * This is the handler that captures mousemove events when an element
  * is being dragged.  It is responsible for moving the element.
  **/
scroll_class.prototype.hsuwak_mousemove = function (e) {
  	e = (!e) ? window.event : e;  // IE event model

    // Move the element to the current mouse position, adjusted as
  	// necessary by the offset of the initial mouse click.
  	var delta   = (e.clientY - this.start_y );
  	var newTop  = this.start_top  + delta;

    //window.status =  "clientX = " + e.clientX + "startX  = " + startX + 'newWidth = ' + newWidth;

  	if( newTop > this.suwak_max_top ){
      this.o_suwak.style.top = this.suwak_max_top;
      this.o_slider.scrollTop = this.o_slider.scrollHeight - this.o_slider.clientHeight;

      //resizeElement.style.visibility = 'visible';
    }else if( newTop < 0 ){
      this.o_suwak.style.top  = 0;
      this.o_slider.scrollTop = 0;
      //resizeElement.style.visibility = 'hidden';
    }else{
      this.o_suwak.style.top = newTop;
      this.o_slider.scrollTop = Math.round(newTop / this.proporcja);

      //resizeElement.style.visibility = 'visible';
    }

  	//resizeElement.style.left = (e.clientX - deltaX) + "px";
  	//resizeElement.style.top = (e.clientY - deltaY) + "px";

  	// And don't let anyone else see this event.
  	if (e.stopPropagation)
        e.stopPropagation();       // DOM Level 2
  	else
        e.cancelBubble = true;                       // IE
}

/**
   * This is the handler that captures the final mouseup event that
   * occurs at the end of a drag.
**/
scroll_class.prototype.hsuwak_mouseup = function (e) {
  	if (!e) e = window.event;  // IE event model

  	var delta   = (e.clientY - this.start_y );
  	var newTop  = this.start_top  + delta;

  	//window.status =  "clientX = " + e.clientX + "startX  = " + startX + 'newWidth = ' + newWidth;

  	if( newTop > this.suwak_max_top ){
      this.o_suwak.style.top = this.suwak_max_top;
      this.o_slider.scrollTop = this.o_slider.scrollHeight - this.o_slider.clientHeight;

      //resizeElement.style.visibility = 'visible';
    }else if( newTop < 0 ){
      this.o_suwak.style.top  = 0;
      this.o_slider.scrollTop = 0;
      //resizeElement.style.visibility = 'hidden';
    }else{
      this.o_suwak.style.top = newTop;
      this.o_slider.scrollTop = Math.round(newTop / this.proporcja);

      //resizeElement.style.visibility = 'visible';
    }


  	// Unregister the capturing event handlers.
  	if (document.removeEventListener) {    // DOM Event Model
  	    document.removeEventListener("mouseup", f_mouseup, true);
  	    document.removeEventListener("mousemove", f_mousemove, true);
  	}else if (document.detachEvent) {       // IE 5+ Event Model
  	    document.detachEvent("onmouseup", f_mouseup);
  	    document.detachEvent("onmousemove", f_mousemove);
  	}	else {                                 // IE 4 Event Model
  	    document.onmouseup = this.olduphandler;
  	    document.onmousemove = this.oldmovehandler;
  	}

  	// And don't let the event propagate any further.
  	if (e.stopPropagation)
        e.stopPropagation();       // DOM Level 2
  	else
        e.cancelBubble = true;                       // IE
}

