CREATE GENERATOR WWW_LANG_ID_GEN;

CREATE GENERATOR WWW_KUPONY_ID_GEN;

CREATE GENERATOR WWW_GRATIS_ID_GEN;

CREATE DOMAIN FILE_EXT_D AS
  VARCHAR(4) CHARACTER SET WIN1250
  COLLATE WIN1250;


CREATE DOMAIN ADRES_IP_D AS
  VARCHAR(15) CHARACTER SET WIN1250
  DEFAULT '0.0.0.0'
  COLLATE WIN1250;



CREATE TABLE WWW_ZK (
  ID INTEGER NOT NULL,
  USER_ID INTEGER NOT NULL,
  PLATNOSC_TYP INTEGER NOT NULL,
  PLATNOSC_KANAL VARCHAR(4) CHARACTER SET WIN1250 COLLATE WIN1250,
  PLATNOSC_STATUS INTEGER,
  PAYBACK_LOGIN VARCHAR(64) CHARACTER SET WIN1250 COLLATE WIN1250,
  ADRES_IP ADRES_IP_D,
  TASK_ID INTEGER);

/* Privileges of roles */
GRANT ALL ON WWW_ZK TO WWW_ROLE;

ALTER TABLE WWW_ZK ADD CONSTRAINT PK_WWW_ZK PRIMARY KEY (ID);

ALTER TABLE WWW_ZK ADD CONSTRAINT WWW_ZK_TASK_ID_FK FOREIGN KEY (TASK_ID) REFERENCES CRM_TASKS(ID) ON DELETE SET NULL ON UPDATE SET NULL;

ALTER TABLE WWW_ZK ADD CONSTRAINT WWW_ZK_USER_ID_FK FOREIGN KEY (USER_ID) REFERENCES WWW_USERS(ID) ON DELETE SET NULL ON UPDATE SET NULL;

CREATE INDEX WWW_ZK_USER_ID ON WWW_ZK(USER_ID);


DROP TABLE WWW_RABATY;

DROP TABLE WWW_HISTORIA_CEN;

DROP TABLE WWW_CHAT_USERS;

DROP TABLE WWW_CHAT;

DROP DOMAIN STRING60_ISO_D;

DROP DOMAIN STRING50_ISO_D;

DROP DOMAIN STRING30_ISO_D;

DROP DOMAIN STRING250_ISO_D;

DROP DOMAIN STRING20_ISO_D;

DROP DOMAIN STRING15_ISO_D;

DROP DOMAIN STRING10_ISO_D;

DROP DOMAIN STRING100_ISO_D;

ALTER TABLE WWW_USERS ADD FIRMA BOOLEAN_D DEFAULT 0 NOT NULL;

ALTER TABLE WWW_USERS ADD LICZBA_LOGOWAN INTEGER DEFAULT 0;

ALTER TABLE WWW_USERS ADD NEWSLETTER BOOLEAN_D NOT NULL;

ALTER TABLE WWW_ONLINE ADD ADRES_IP ADRES_IP_D;

ALTER TABLE WWW_KOSZYK_POZ ADD RABAT SMALLINT;

ALTER TABLE WWW_KOSZYK_POZ ADD RABAT_ID INTEGER;

ALTER TABLE WWW_KOSZYK_POZ ADD CENAB_WAL CENA_D NOT NULL;

ALTER TABLE WWW_KOSZYK_POZ ADD CENA_WAL CENA_D NOT NULL;

ALTER TABLE WWW_KOSZYK_POZ ADD CENAB WARTOSC_D DEFAULT 0 NOT NULL;

ALTER TABLE WWW_KOSZYK_POZ ADD CENA WARTOSC_D NOT NULL;

ALTER TABLE WWW_KOSZYK_POZ ADD WALUTA INTEGER;

ALTER TABLE WWW_KOSZYK_POZ ADD CENA_ID SMALLINT;

ALTER TABLE WWW_KOSZYK_POZ ADD OPK_ILOSC ILOSC_D NOT NULL;

ALTER TABLE WWW_KOSZYK_POZ ADD OPK_ID INTEGER;

ALTER TABLE WWW_KOSZYK ADD RABAT PROCENT_D;

ALTER TABLE WWW_KOSZYK ADD RABAT_ID INTEGER;

ALTER TABLE WWW_KOSZYK ADD WALUTA INTEGER;

ALTER TABLE WWW_KOSZYK ADD CENA_ID INTEGER;

ALTER TABLE WWW_KOSZYK ADD PLATNIK_ID INTEGER;

ALTER TABLE WWW_KOSZYK ADD ODBIORCA_ID INTEGER;

ALTER TABLE WWW_KOSZYK ADD CONTACT_ID INTEGER;

ALTER TABLE WWW_GRUPYT_EXT ADD RADAR_ID INTEGER;

ALTER TABLE WWW_GRUPYT_EXT ADD IMG VARCHAR(250) CHARACTER SET WIN1250 COLLATE WIN1250;

ALTER TABLE WWW_GRUPYT ADD RADAR_ID INTEGER;

ALTER TABLE WWW_GRUPYT ADD IMG VARCHAR(250) CHARACTER SET WIN1250 COLLATE WIN1250;

ALTER TABLE WWW_KOSZYK_POZ
ALTER COLUMN ILOSC
TYPE NUMERIC(15, 4);
update rdb$relation_fields set
rdb$null_flag = 1
where (rdb$field_name = 'ILOSC')
and (rdb$relation_name = 'WWW_KOSZYK_POZ');

CREATE INDEX WWW_UWAGI_LINK_IND ON WWW_UWAGI(LINK);


CREATE INDEX WWW_UWAGI_ADRES_IP_IND ON WWW_UWAGI(ADRES_IP);


CREATE INDEX WWW_USERS_NEWSLETTER_IND ON WWW_USERS(NEWSLETTER);


CREATE UNIQUE INDEX WWW_KOSZYK_USER_NAZWA_UK ON WWW_KOSZYK(USER_ID,NAZWA);


CREATE INDEX WWW_KOSZYK_DOMYSLNY_IND ON WWW_KOSZYK(DOMYSLNY);


CREATE INDEX WWW_KOSZYK_DATY_IND ON WWW_KOSZYK(CDATE,MDATE);


CREATE INDEX WWW_ERRORS_PLIK_IND ON WWW_ERRORS(PLIK);


CREATE INDEX WWW_ERRORS_NUMER_IND ON WWW_ERRORS(NUMER);


CREATE INDEX WWW_ERRORS_DATA_IND ON WWW_ERRORS(DATA);


CREATE INDEX WWW_ERRORS_ADRES_IP_IND ON WWW_ERRORS(ADRES_IP);


ALTER TABLE WWW_GRUPYT_EXT ADD CONSTRAINT WWW_GRUPYT_EXT_ID_PARENT_FK FOREIGN KEY (ID_PARENT) REFERENCES WWW_GRUPYT_EXT(ID) ON DELETE CASCADE ON UPDATE CASCADE;


ALTER TABLE WWW_GRUPYT_EXT ADD CONSTRAINT WWW_GRUPYT_EXT_ID_FK FOREIGN KEY (ID) REFERENCES GM_GRUPYT_EXT(ID) ON DELETE CASCADE ON UPDATE CASCADE;


ALTER TABLE WWW_GRUPYT ADD CONSTRAINT WWW_GRUPYT_ID_PARENT_FK FOREIGN KEY (ID_PARENT) REFERENCES WWW_GRUPYT(ID) ON DELETE CASCADE ON UPDATE CASCADE;


ALTER TABLE WWW_GRUPYT ADD CONSTRAINT WWW_GRUPYT_ID_FK FOREIGN KEY (ID) REFERENCES GM_GRUPYT(ID) ON DELETE CASCADE ON UPDATE CASCADE;


